;
;   Random BMP Put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;

;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     temp_area , 0x0         ; I_Param , I_Icon

;******************************************************************************




include 'ascl.inc'
include 'ascgl.inc'


START:                          ; start of execution
    call draw_window

    loadbmp '/RD/1/MFAR.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img
    loadbmp '/RD/1/SMILE.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img2
    loadbmp '/RD/1/COPY.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img3
    loadbmp '/RD/1/GAME.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img4
    loadbmp '/RD/1/3FLOPPY.BMP',temp_area,I_END,tsoi
    bmptoimg I_END,tsoi,img5


still:

    mov  eax,11                 ; scan event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button
    mov dword [counter],10
put_loop:
;    setbmp  dword [xt],dword [yt],I_END,dword [tsoi]
    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],25
    setimg dword [xt],dword [yt],img

    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],25
    setimg dword [xt],dword [yt],img2 ;2

    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],25
    setimg dword [xt],dword [yt],img3

    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],25
    setimg dword [xt],dword [yt],img4

    random 640-32 ,dword [xt]
    random 480-32 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],25
    setimg dword [xt],dword [yt],img5

    dec dword [counter]
    jnz put_loop

    delay 1             ;don't generate delay for fast speed programm

    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    int  0x40
    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still


draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'2D EXAMPLE: RANDOM PUT IMAGE',cl_White+font_Big
;    call load_image
    endwd
    ret


; DATA AREA
xt dd 100
yt dd 100

counter dd 0
tsoi dd 0
tsoi2 dd 0
tsoi3 dd 0

IM_END:

img:
rd 32*32*3+8
img2:
rb 32*32*3+8
img3:
rb 32*32*3+8
img4:
rb 32*32*3+8
img5:
rb 32*32*3+8

temp_area:
rb 0x15000

I_END:
