;
;   Random color put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;

;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     0x0 , 0x0         ; I_Param , I_Icon

;******************************************************************************
include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    call draw_window

still:
    scevent red,key,button

    mov dword [counter],10
put_loop:
    random 320-1 ,dword [xt]
    random 240-1 ,dword [yt]
    random 65536 , eax  ;regeneration for more combinations
    add dword [xt],5
    add dword [yt],23

    random 255 ,esi
    shl esi,16 ; 16 - red
    add esi,font_Big
    putpix [xt],[yt],esi

    dec dword [counter]
    jnz put_loop
;    delay 1             ;don't generate delay for fast speed programm
    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    int  0x40
    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
;    cmp  ah,1                   ; button id=1 ?
;    jne  noclose
;    mov  eax,-1                 ; close this program
;    int  0x40
;  noclose:
;    jmp  still      ; for little size
    close

draw_window:
    startwd
    window 0,0,320+8,240+24,window_Skinned
    label 12,8,'2D EXAMPLE: RANDOM PUT PIX',cl_White+font_Big
    endwd
    ret

; DATA AREA
xt dd 100
yt dd 100
counter dd 0

IM_END:
I_END:
