;                        .
; Long File Names        .
;                        .
; Author:                .
;       vHanLa           .
;                        .
; Compile with FASM      .
;.........................
; v0.1     :-2k5-OCT-1st :
;.........................
;
;-------------------------------------------------------------------;
; --> If there is no long file name block, textlength will be 0 <-- ;
;-------------------------------------------------------------------;

;Used for keeping the long name of the current file or folder
LFN_TEXT_BUFFER: times 255 db 0x20     ; filled with spaces
;used for keeping the length of the current long name
LFN_TEXT_LENGTH db 0
;used for detecting the existence of LFN Format Into a 32 block
LFN_EXISTS db 0

LFN: ; NOTICE: EDX must be pointing to the first letter of the 8.3 name format
	pusha

	mov [LFN_TEXT_LENGTH], 0
	mov al, [EDX-32]
	shl al, 2
	shr al, 2
	cmp al, 0x01
	jne NO_LFN
	mov al, [EDX-32+11]
	cmp al, 0x0F
	jne NO_LFN

	mov [LFN_EXISTS], 1

	xor ebx,ebx ; i will use this register
	add edx, 32

LFN_START:
	sub edx, 64
	inc edx
	mov ecx, 5
;......................................................
LFN_LOOP1:	 ;it uses ECX as a COUNTER
	mov ax, [edx]
	cmp ax, 0x0000
	je LFN_END

	mov ax, [EDx]
	cmp ax, 0xFFFF
	je LFN_END

	mov bl, [LFN_TEXT_LENGTH]
	mov [LFN_TEXT_BUFFER+bx], al
	inc [LFN_TEXT_LENGTH]
	add edx, 2
	loop LFN_LOOP1
;......................................................
	add edx, 3
	mov ecx, 6
;......................................................
LFN_LOOP2:	 ;it uses ECX as a COUNTER
	mov ax, [edx]
	cmp ax, 0x0000
	je LFN_END

	mov ax, [EDx]
	cmp ax, 0xFFFF
	je LFN_END

	mov bl, [LFN_TEXT_LENGTH]
	mov [LFN_TEXT_BUFFER+bx], al
	inc [LFN_TEXT_LENGTH]
	add edx, 2
	loop LFN_LOOP2
;......................................................
	add edx, 2
	mov ecx, 2
;......................................................
LFN_LOOP3:	 ;it uses ECX as a COUNTER
	mov ax, [edx]
	cmp ax, 0x0000
	je LFN_END

	mov ax, [EDx]
	cmp ax, 0xFFFF
	je LFN_END

	mov bl, [LFN_TEXT_LENGTH]
	mov [LFN_TEXT_BUFFER+bx], al
	inc [LFN_TEXT_LENGTH]
	add edx, 2
	loop LFN_LOOP3
;......................................................
	;if this was the last 32LFN block, we'll stop!!!
	mov al, [edx-32]
	and al, 01000000b	; 6th bit =0 if not 32LFN block
	jnz LFN_END

	jmp LFN_START

NO_LFN:
	mov [LFN_EXISTS],0

LFN_END:

	popa
	ret